#ifndef __CONTAINER_H__
#define __CONTAINER_H__

template <class T>
class ObjList
{
public:
	ObjList(void){ clear(); }

	~ObjList(void){
		if (data)
			free(data);
		data_size=0;
		capacity=0;
	}

	ObjList(const ObjList &l){
		this->operator =(l);	
	}

	void push_back(T i){
		if (data_size>=capacity)
		{
			capacity *= 2;
			data = (T*)realloc(data,capacity*sizeof(T));
		}
		data[data_size] = i;
		data_size++;
	}

	T & operator[](unsigned int i){ assert(i<data_size); return data[i]; }
	const T & operator[](unsigned int i) const { assert(i<data_size); return data[i]; }

	const ObjList & operator=(const ObjList &l){
/*		capacity=l.capacity;
		data_size=l.data_size;
		data=(T*)malloc(capacity*sizeof(T));
		memcpy(data,l.data,data_size*sizeof(T));*/
		clear();
		for (unsigned int i=0; i<l.size(); i++)
			push_back(l[i]);
		return l;
	}

	unsigned int size(void) const { return data_size; }

	void clear(void){
		capacity=16;
		data=(T*)malloc(capacity*sizeof(T));
		data_size=0;
	}

	void eraseAtPos(unsigned int i){
		if (i!=data_size-1)
			memmove(data+i,data+i+1,(data_size-i-1)*sizeof(T));
		data_size--;
	}

private:
	T *data;
	unsigned int data_size;
	unsigned int capacity;
};

#endif
